

class State:
    def __init__(self):
        self.parent=None

    def handleMouseButton(self, bDown, buttonIndex):
        return False

    def handleKey(self, key):
        return False

    def init(self):
        pass

    def activateApp(self, bNowActive):
        return False

        

gStateStack=[]

def pushState(newState):
    try:
        oldTop=gStateStack[-1]
    except:
        oldTop=None

    gStateStack.append(newState)
    newState.parent=oldTop
    newState.init()
        

def popState():
    gStateStack.pop()
    

def popAll():
    global gStateStack
    gStateStack=[]


def handleKey(k):
    for s in reversed(gStateStack):
        if s.handleKey(k):
            return True
    return False

def handleActivate(bNowActive):
    for s in reversed(gStateStack):
        if s.activateApp(bNowActive):
            return True
    return False

def handleMouseButton(bDown, button):
    for s in reversed(gStateStack):
        if s.handleMouseButton(bDown, button):
            return True
    return False

def update(ms):
    if not len(gStateStack):
        return False
    
    gStateStack[-1].update(ms)
    return True


def draw():
    if not len(gStateStack):
        return

    gStateStack[-1].draw()

    
