# This is an example setup.py file
# run it from the windows command line like so:
# > C:\Python24\python.exe setup.py py2exe --bundle 1
# or see the makeExe.bat file in this directory
 
from distutils.core import setup
 
import py2exe, glob
 
opts = { 
 "py2exe": { 
   # if you import .py files from subfolders of your project, then those are
   # submodules.  You'll want to declare those in the "includes"
   #'includes':['data',
   #            'data.glarf',
   #            'data.glarf.chardef',
   #           ],
    
    #'excludes':['OpenGL'],
    'optimize':2,
 } 
} 
 
setup(
 
  #this is the file that is run when you start the game from the command line.  
  console=[{'script':'main.py',
            'icon_resources':[(1, 'Data/WTIPD.ico')],
            'dest_base':'wtipd_dos',
           }],

  windows=[{'script':'main.py',
            'icon_resources':[(1, 'Data/WTIPD.ico')],
            'dest_base':'wtipd_win',
           }],
  
 
  #options as defined above
  options=opts,
 
  #data files - these are the non-python files, like images and sounds
  #the glob module comes in handy here.
  data_files = [
    ("data", glob.glob("data\\*.png") + glob.glob("data\\*.ico")),
  ],
 
  #this will pack up a zipfile instead of having a glut of files sitting
  #in a folder.
  # this is if you specified bundle 2 on the command line
  #zipfile="lib/shared.zip",

  # this is if you specified bundle 1 on the command line
  zipfile=None,

  
  name="WTIPD - BDG PyWeek4 Entry",
  version="0.0.1"
)
