import math
import sys

from OpenGL.GL import *
from OpenGL.GLU import *
import pygame, pygame.image
from pygame.locals import *

import fsmMgr
import mouseInfo

import statePlayAd
import stateDialog
import level1
import stateAim
import edgesMenu
import widgets
import tutorialProgress
import playerMgr
import stateMainMenu
import screenInfo
import fade       

def restartLevel():
    level1.thisLevel.setLevel(level1.thisLevel.level)
    level1.thisLevel.gameInPlay=True
    fsmMgr.popState()


def goToMainMenu():
    level1.thisLevel.gameInPlay=True
    fsmMgr.popAll()
    fsmMgr.pushState(stateMainMenu.StateMainMenu(None))

def resumeGame():
    level1.thisLevel.gameInPlay=True
    fsmMgr.popState()

class StatePauseMenu(fsmMgr.State):
    def __init__(self, data):
        fsmMgr.State.__init__(self)

        self.clicked=False


        self.left=300
        self.right=500
        self.top=450
        self.bottom=150
        
        self.widgets=[widgets.Button(40,350,8,"Resume",resumeGame),
                      widgets.Button(40,300,8,"Restart Level",restartLevel),
                      widgets.Button(40,250,8,"Main Menu",goToMainMenu),
                      widgets.Button(40,200,8,"Quit",lambda:fsmMgr.popAll())
                      ]

        maxWidth=max(map(lambda x:x.width,self.widgets))
        for w in self.widgets:
            w.setWidth(maxWidth)
            w.x=400-maxWidth/2

        self.left = 400-maxWidth/2-50
        self.right = 400+maxWidth/2+50

        wx,wy=screenInfo.worldToScreenPos(400,self.top)
        #pygame.mouse.set_pos(wx,wy)




    def update(self, dt):
        dt=dt/1000.0

        mouseInfo.readMouse()
        for w in self.widgets:
            w.update(dt)

    def draw(self):
        self.parent.draw()

        glMatrixMode(GL_PROJECTION)
        glPushMatrix()
        glLoadIdentity()
        gluOrtho2D(0,800,0,600)
        
        
        glColor3f(0,0,0)
        glBegin(GL_QUADS)
        glVertex(self.left,self.bottom)
        glVertex(self.right,self.bottom)
        glVertex(self.right,self.top)
        glVertex(self.left,self.top)
        glEnd()

        glColor3f(*fade.DIM_COLOR)
        glBegin(GL_LINE_LOOP)
        glVertex(self.left,self.bottom)
        glVertex(self.right,self.bottom)
        glVertex(self.right,self.top)
        glVertex(self.left,self.top)
        glEnd()
        
        for w in self.widgets:
            w.draw()

        glPopMatrix()
        glMatrixMode(GL_MODELVIEW)
            

    def handleMouseButton(self, bDown, buttonIndex):
        mouseInfo.readMouse()
        if bDown and buttonIndex==1:
            for w in self.widgets:
                if w.isMouseInMe():
                    w.callbackFunc()
        return True

    def done(self):
        fsmMgr.popState()

    

